package org.wso2.carbon.core.persistence;

import org.apache.axis2.description.AxisModule;
import org.apache.axis2.description.AxisOperation;
import org.apache.axis2.description.AxisService;
import org.apache.axis2.description.AxisServiceGroup;
import org.apache.axis2.description.Parameter;
import org.wso2.carbon.core.RegistryResources;

public class PersistenceUtils {

    public static String getResourcePath(AxisServiceGroup serviceGroup) {

        String path = RegistryResources.SERVICE_GROUPS + serviceGroup.getServiceGroupName();

        return path;
    }

    public static String getResourcePath(AxisService service) {

        String path = RegistryResources.SERVICE_GROUPS
                + service.getAxisServiceGroup().getServiceGroupName() + RegistryResources.SERVICES
                + service.getName();

        return path;
    }

    public static String getResourcePath(AxisOperation operation) {

        AxisService service = operation.getAxisService();

        String path = RegistryResources.SERVICE_GROUPS
                + service.getAxisServiceGroup().getServiceGroupName() + RegistryResources.SERVICES
                + service.getName() + RegistryResources.ServiceProperties.OPERATIONS
                + operation.getName().getLocalPart();

        return path;
    }

    public static String getResourcePath(AxisModule module) {
        String path;
        if (module.getVersion() != null) {
            path = RegistryResources.MODULES + module.getName() + "/" + module.getVersion();
        } else {
            path = RegistryResources.MODULES + module.getName() + "/" + RegistryResources.ModuleProperties.UNDEFINED;
        }
        return path;
    }

    public static String getResourcePath(AxisModule module, Parameter param) {

        return getResourcePath(module) + RegistryResources.PARAMETERS + param.getName();
    }

}
