/*
 * Copyright (c) 2007, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.carbon.registry.app;

import org.wso2.carbon.registry.core.Resource;
import org.apache.abdera.util.EntityTag;
import org.apache.abdera.model.AtomDate;

import java.util.Date;

public class APPUtils {
    public static String generateID(String base, String suffix) {
        return "tag:" + base + suffix;
    }

    /**
     * Cacluate the entity tag based on the resource, this is
     * equivelent to the RegistryAdapter::calculateEntityTag function
     * which calculate entity tag based on the feed
     * @param r Resource
     * @return  cacluated entitiy tag as a string
     */
    public static String calculateEntityTag(Resource r) {
        String id = "urn:uuid:" + Utils.getUUID(r.getId());
        Date modifiedDate = r.getLastModified();
        String modified = AtomDate.valueOf(modifiedDate).getValue();

        return EntityTag.generate(id, modified).toString();
    }
}
