/*
* Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/



package org.wso2.carbon.registry.app;
import org.wso2.carbon.registry.core.exceptions.RegistryException;


import org.wso2.carbon.registry.core.Resource;

import java.util.HashMap;
import java.util.Map;
import java.sql.Timestamp;

public class CachedResources {

    private Map<String,Resource> resource;
    private Map<String,String>  etag;

    public CachedResources(){
        resource = new HashMap();
        etag = new HashMap();
    }

    public boolean CheckCachedResource(String path){
        if(!resource.isEmpty())
        return resource.containsKey(path);

        return false;

    }
    public boolean CacheNewResource(String path,Resource getresource,String Etag,long size){
        if(resource.get(path) != null){
           // This scenario comes when user changed the resource meantime and now we are going to put that
            //modified resource in to hashtable,before modifieing it we are removing the current one
            resource.remove(path);
            etag.remove(path);          
        }
            if(getsizeofcache() < size)
            {
                resource.put(path,getresource);
                etag.put(path,Etag);
                return true;
            }
        return false;
    }
    public Resource getcachedresource(String path)
    {
        return (Resource)resource.get(path);
    }
    public String getEtag(String path){
       return etag.get(path);
    }
    public int getsizeofcache()
    {
        return resource.size();
    }
}
