/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.app;

import org.apache.abdera.protocol.server.context.SimpleResponseContext;
import org.apache.axiom.om.OMElement;
import org.wso2.carbon.registry.core.Registry;
import org.wso2.carbon.registry.core.exceptions.RegistryException;

import javax.xml.stream.XMLStreamException;
import java.io.Writer;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.OutputStream;

public class OMElementResponseContext  extends SimpleResponseContext {

    Registry registry;
    String path;

    public OMElementResponseContext(Registry registry, String path) {
        this.registry = registry;
        this.path = path;
    }

    /**
     * Write either the full stack trace or just the Exception message, depending on config
     *
     * @param writer the Writer connected to the HTTP response
     * @throws java.io.IOException
     */
    protected void writeEntity(Writer writer) throws IOException {
        try {
            registry.dump(path, writer);
            //e.serialize(writer);
        }
        catch (RegistryException e) {
            throw new IOException("Falied in dumping the path " +  path + ". " + e.getMessage());
        }
    }

    public boolean hasEntity() {
        return true;
    }
}
