/*
 * Copyright (c) 2007, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.carbon.registry.core;

import org.wso2.carbon.registry.core.exceptions.RegistryException;

public interface Collection extends Resource {
    public static final String ALLOW_ALL = "ALLOW_ALL";
    public static final String ALLOW_SELECTED = "ALLOW_SELECTED";
    public static final String DENY_SELECTED = "DENY_SELECTED";

    String [] getChildren() throws RegistryException;

    String [] getChildren(int start, int pageLen) throws RegistryException;

    int getChildCount() throws RegistryException;
}
