/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.core.jdbc;

public class DatabaseConstants {

    // database context name
    public static final String REGISTRY_DATASOURCE_NAME = "java:comp/env/jdbc/WSO2RegistryDB";
    public static final String USER_MANAGER_DATASOURCE_NAME =
            "java:comp/env/jdbc/WSO2UserManagerDB";
    public static final String HSQL_DRIVER_NAME = "org.hsqldb.jdbcDriver";

    // Field names of Resource table
    public static final String AID_FIELD = "REG_RID";
    public static final String PATH_FIELD = "REG_PATH";
    public static final String DIRECTORY_FIELD = "REG_DIRECTORY";
    public static final String STATE_FIELD = "REG_STATE";
    public static final String MEDIA_TYPE_FIELD = "REG_MEDIA_TYPE";
    public static final String AUTHOR_FIELD = "REG_AUTHOR";
    public static final String CREATED_TIME_FIELD = "REG_CREATED_TIME";
    public static final String DESCRIPTION_FIELD = "REG_DESCRIPTION";
    public static final String LAST_UPDATER_FIELD = "REG_LAST_UPDATER";
    public static final String LAST_UPDATED_TIME_FIELD = "REG_LAST_UPDATED_TIME";
    public static final String CONTENT_FIELD = "REG_CONTENT";

    // Field names of Children table
    public static final String PARENT_ID_FIELD = "REG_PARENT_ID";
    public static final String CHILD_ID_FIELD = "REG_CHILD_ID";

    // Field names of Versions table
    public static final String VERSION_NUMBER_FIELD = "VN";
    public static final String VERSION_CONTENT_FIELD = "CONTENT";
    public static final String VERSION_AUTHOR_FIELD = "AUTHOR";
    public static final String VERSION_UPDATED_TIME = "UPDATED_TIME";

    // Field names of Properties table
    public static final String PROPERTY_ID_FIELD = "P_ID";
    public static final String ARTIFACT_ID_FIELD = "AID";
    public static final String PROPERTY_KEY_FIELD = "PKEY";
    public static final String PROPERTY_VALUE_FIELD = "PVALUE";

    // Field names of Tags tabel
    public static final String TAG_ID_FIELD = "REG_TAG_ID";
    public static final String TAG_NAME_FIELD = "REG_TAG_NAME";

    // Field names of Taggings table
    public static final String TAGGED_TIME_FIELD = "REG_TAGGED_TIME";
    public static final String TAGGING_ID_FIELD = "REG_TAG_ID";

    // Field names of Comments table
    public static final String COMMENT_ID_FIELD = "REG_COMMENT_ID";
    public static final String COMMENT_TEXT_FIELD = "REG_COMMENT_TEXT";
    public static final String COMMENTED_USER_ID_FIELD = "REG_USER_ID";
    public static final String COMMENTED_TIME_FIELD = "REG_COMMENTED_TIME";

    // Field names of logs table
    public static final String LOGGED_TIME_FIELD = "REG_LOGGED_TIME";
    public static final String ACTION_FIELD = "REG_ACTION";
    public static final String ACTION_DATA_FIELD = "REG_ACTION_DATA";

    // Field names of Ratings table
    public static final String RATING_ID_FIELD = "REG_RATING_ID";
    public static final String RATED_TIME_FIELD = "REG_RATED_TIME";
    public static final String RATING_FIELD = "REG_RATING";

    // user ID field common for most tables
    public static final String USER_ID_FIELD = "REG_USER_ID";

}
