/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.core.jdbc;

import org.wso2.carbon.registry.core.config.RegistryContext;
import org.wso2.carbon.registry.core.exceptions.RegistryException;
import org.wso2.carbon.registry.core.jdbc.realm.InMemoryRegistryRealm;
import org.wso2.carbon.user.core.UserRealm;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class InMemoryEmbeddedRegistry extends EmbeddedRegistry {

    private static final Log log = LogFactory.getLog(InMemoryEmbeddedRegistry.class);

    public InMemoryEmbeddedRegistry() throws RegistryException {

        UserRealm realm = new InMemoryRegistryRealm();
        registryContext = new RegistryContext(realm);
        registryContext.setSetup(true);
        registryContext.selectDBConfig("h2-db");
        super.configure(realm);
    }

    public InMemoryEmbeddedRegistry(UserRealm defaultRealm) throws RegistryException {
        
        registryContext = new RegistryContext(defaultRealm);
        registryContext.setSetup(true);
        registryContext.selectDBConfig("h2-db");
        super.configure(defaultRealm);
    }
}
