/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.core.jdbc.utils;

import java.sql.Connection;

public class Transaction {

    private static ThreadLocal <Boolean> tStarted = new ThreadLocal <Boolean> () {
        protected Boolean intialValue() {
            return false;
        }
    };

    private static ThreadLocal <Connection> tConnection = new ThreadLocal <Connection> () {
        protected Connection initialValue() {
            return null;
        }
    };

    public static boolean isStarted() {
        if (tStarted.get() == null) {
            return false;
        }

        return tStarted.get();
    }

    public static void setStarted(boolean started) {
        tStarted.set(started);
    }

    public static Connection getConnection() {
        return tConnection.get();
    }

    public static void setConnection(Connection connection) {
        if (connection != null) {
            tStarted.set(true);
        }
        tConnection.set(connection);
    }

    public static void removeConnection() {
        tStarted.remove();
        tConnection.remove();
    }
}
