/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.core.session;

import org.wso2.carbon.registry.core.RegistryConstants;
import org.wso2.carbon.user.core.UserRealm;

public class CurrentSession {

    private static ThreadLocal <String> tUserID = new ThreadLocal <String> () {
        protected String initialValue() {
            return RegistryConstants.ANONYMOUS_USER;
        }
    };

    private static ThreadLocal <UserRealm> tUserRealm = new ThreadLocal <UserRealm> () {
        protected UserRealm initialValue() {
            return null;
        }
    };

    public static String getUser() {
        return tUserID.get();
    }

    public static void setUser(String userID) {
        tUserID.set(userID);
    }

    public static void removeUser() {
        tUserID.remove();
    }

    public static UserRealm getRealm() {
        return tUserRealm.get();
    }

    public static void setRealm(UserRealm userRealm) {
        tUserRealm.set(userRealm);
    }

    public static void removeRealm() {
        tUserRealm.remove();
    }
}
