package org.wso2.carbon.ui;

import java.rmi.RemoteException;

import javax.servlet.http.HttpServletRequest;

public abstract class CarbonAuthenticator {

	/**
	 * 
	 * @param request
	 */
	public CarbonAuthenticator(HttpServletRequest request) {

	}

	/**
	 * Authenticates user based on the credentials contained in the request.
	 * 
	 * @param request
	 * @return
	 * @throws RemoteException
	 */
	public abstract boolean authenticate() throws RemoteException;

	/**
	 * Invalidates the authenticated session for the logged in user.
	 * 
	 * @param request
	 */
	public abstract void unauthenticate();

	/**
	 * Returns the authenticated user name
	 */
	public abstract String getAuthenticatedUser();
}
