package org.wso2.carbon.user.core;

import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

public class AuthorizationCache {
    
    private class UserRoleItem{
	public String[] roles = null;
	public Date lastAccessed = null;
    }

    private class AuthorizedItem{
	public boolean isAuthorized = false;
	public Date lastAccessed = null;
    }
    
    private Map<String, UserRoleItem> userRoles = new ConcurrentHashMap<String, UserRoleItem>();
    private Map<String, AuthorizedItem> authzedMap = new ConcurrentHashMap<String, AuthorizedItem>();
    
    
    public String[] getUserRoles(String user){
	UserRoleItem item = userRoles.get(user);
	if(item != null){
	    item.lastAccessed = new Date();
	    return item.roles;
	}
	return null;
    }
    

    public Boolean addAuthorized(String user){
	AuthorizedItem item = authzedMap.get(user);
	if(item != null){
	    item.lastAccessed = new Date();
	    return item.isAuthorized;
	}
	return null;
    }
    
    public void isAuthorized(String user, boolean isAuthzed){
	AuthorizedItem item = new AuthorizedItem();
	item.isAuthorized = isAuthzed;
	item.lastAccessed = new Date();
	authzedMap.put(user, item);
    }
    
    public void addUserRoles(String user, String[] roles){
	UserRoleItem item = new UserRoleItem();
	item.roles = roles;
	item.lastAccessed = new Date();
	userRoles.put(user, item);
    }
    
    public void onTimer(){
	Calendar cal1 = Calendar.getInstance();
	cal1.add(Calendar.MINUTE, -15);
	Calendar cal2 = Calendar.getInstance();
		
	Iterator<Entry<String,AuthorizedItem>> ite2 = authzedMap.entrySet().iterator();
	while(ite2.hasNext()){
	    Entry<String,AuthorizedItem> entry = ite2.next();
	    AuthorizedItem item = entry.getValue();
	    Date lastAccessed = item.lastAccessed;
	    cal2.setTime(lastAccessed);
	    if(cal1.compareTo(cal2)>0){
		ite2.remove();
	    }
	}
	
	Iterator<Entry<String,UserRoleItem>> ite1 = userRoles.entrySet().iterator();
	while(ite1.hasNext()){
	    Entry<String,UserRoleItem> entry = ite1.next();
	    UserRoleItem item = entry.getValue();
	    Date lastAccessed = item.lastAccessed;
	    cal2.setTime(lastAccessed);
	    if(cal1.compareTo(cal2)>0){
		ite1.remove();
	    }
	}	
    }

}
