package org.wso2.carbon.user.core;

public class Claim {

    // An URI to uniquely identify a given claim. This is the one used by the
    // top layers applications are aware of.
    private String claimUri;

    // This is the value that should be displayed on the UI - when claims are
    // taken to the front
    // end.
    private String displayTag;

    // This is a detailed description of the claim.
    private String description;

    // This are claim asked at the time of registration. Privileged users will
    // be able to mark
    // claims those are not supported by default as 'supported' later. This is a
    // sub-set of the
    // claims read from the claim-config.xml.
    private boolean supportedByDefault;

    // This are claims required at the time user registration.
    private boolean required;

    // Regular expression to validate the claim value - if none is provide, no
    // validation will take
    // place.
    private String regEx;

    // Dialect URI for the claim. Dialect will be useful to group claims.
    private String dialectURI;

    private String value;
    
    private int displayOrder;

    public String getClaimUri() {
        return claimUri;
    }

    public void setClaimUri(String claimUri) {
        this.claimUri = claimUri;
    }

    public String getDisplayTag() {
        return displayTag;
    }

    public void setDisplayTag(String displayTag) {
        this.displayTag = displayTag;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public boolean isSupportedByDefault() {
        return supportedByDefault;
    }

    public void setSupportedByDefault(boolean supportedByDefault) {
        this.supportedByDefault = supportedByDefault;
    }

    public boolean isRequired() {
        return required;
    }

    public void setRequired(boolean required) {
        this.required = required;
    }

    public String getRegEx() {
        return regEx;
    }

    public void setRegEx(String regEx) {
        this.regEx = regEx;
    }

    public String getDialectURI() {
        return dialectURI;
    }

    public void setDialectURI(String dialectURI) {
        this.dialectURI = dialectURI;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getDisplayOrder() {
        return displayOrder;
    }

    public void setDisplayOrder(int displayOrder) {
        this.displayOrder = displayOrder;
    }
}
