package org.wso2.carbon.user.core;

public class UserCoreConstants {

    public static final String INTERNAL_USERSTORE = "Internal";
    public static final String EXTERNAL_USERSTORE = "External";

    public static final String DELEGATING_REALM = "Delegating";
    public static final String DEFAULT_REALM = "Default";
    public static final String HYBRID_REALM = "Hybrid";
    public static final String REALM_GENRE = "RealmGenre";
    public static final String DEFAULT_CARBON_DIALECT = "http://wso2.org/claims";
    public static final String DIGEST_FUNCTION = "DigestFunction";
    public static final String SALTED_PASSWORD = "SaltedPassword";
    
    public static short DENY = 0;
    public static short ALLOW = 1;

    public static final String SYSTEM_RESOURCE = "System";
    
    public static final String EVERYONE_ROLE = "everyone";

    public static final class UserMgtConfig {
        public static final String USER_MGT = "UserManager";
        public static final String URL = "URL";
        public static final String USERNAME = "UserName";
        public static final String PASSWORD = "Password";
        public static final String DRIVER = "Driver";
        public static final String DIALECT = "Dialect";
        //properties describing connection pool
        public static final String MAX_WAIT = "maxWait";
        public static final String MAX_ACTIVE = "maxActive";
        public static final String MAX_IDLE = "maxIdle";
        public static final String MIN_IDLE = "minIdle";
        public static final String VALIDATION_QUERY = "validationQuery";
    }

    public static final String INVOKE_SERVICE_PERMISSION = "invoke-service";
    
    public static final String AUTHZ_CACHE = "AuthzCache";
    public static final String ROLE_CACHE = "RoleCache";
    public static final String USER_ID_CACHE = "UserIdCache";
    public static final String ROLE_ID_CACHE = "RoleIdCache";

    public static final int MAX_OBJECTS_IN_CACHE = 5000;
    public static final int TTL_CACHE = 30;
    public static final int TTL2_CACHE = 300;    
    public static final int IDLE_TIME_IN_CACHE = 0;

    public static final String DEFAULT_PROFILE = "default";
    public static final String DEFAULT_PROFILE_CONFIGURATION = "default";
    public static final String PROFILE_CONFIGURATION = "profileConfiguration";
    public static final String PICTURE_CLAIM = "picture";

    public static final String CLAIM_HIDDEN = "Hidden";
    public static final String CLAIM_OVERRIDEN = "Overridden";
    public static final String CLAIM_INHERITED = "Inherited";

    public static final String AUTHORIZATION_ACTION_LOGIN = "login";
    public static final String AUTHORIZATION_ACTION_MANAGE_CONFIGURATION = "manage-configuration";
    public static final String AUTHORIZATION_ACTION_MANAGE_SECURITY = "manage-security";

    public static final class ClaimTypeURIs {
        public static final String GIVEN_NAME = "/givenname";
        public static final String EMAIL_ADDRESS = DEFAULT_CARBON_DIALECT + "/emailaddress";
        public static final String SURNAME = DEFAULT_CARBON_DIALECT + "/lastname";
        public static final String STREET_ADDRESS = DEFAULT_CARBON_DIALECT + "/streetaddress";
        public static final String LOCALITY = DEFAULT_CARBON_DIALECT + "/locality";
        public static final String REGION = DEFAULT_CARBON_DIALECT + "/region";
        public static final String POSTAL_CODE = DEFAULT_CARBON_DIALECT + "/postalcode";
        public static final String COUNTRY = DEFAULT_CARBON_DIALECT + "/country";
        public static final String HONE = DEFAULT_CARBON_DIALECT + "/telephone";
        public static final String IM = DEFAULT_CARBON_DIALECT + "/im";
        public static final String ORGANIZATION = DEFAULT_CARBON_DIALECT + "/organization";
        public static final String URL = DEFAULT_CARBON_DIALECT + "/url";
        public static final String TITLE = DEFAULT_CARBON_DIALECT + "/title";
        public static final String ROLE = DEFAULT_CARBON_DIALECT + "/role";
        public static final String MOBILE = DEFAULT_CARBON_DIALECT + "/mobile";
        public static final String NICKNAME = DEFAULT_CARBON_DIALECT + "/nickname";
        public static final String DATE_OF_BIRTH = DEFAULT_CARBON_DIALECT + "/dob";
        public static final String GENDER = DEFAULT_CARBON_DIALECT + "/gender";
    }
}
