package org.wso2.carbon.user.core.delegating;

import java.util.List;
import java.util.Map;

import org.wso2.carbon.user.core.UserCoreConstants;
import org.wso2.carbon.user.core.UserRealm;
import org.wso2.carbon.user.core.UserStoreAdmin;
import org.wso2.carbon.user.core.UserStoreException;
import org.wso2.carbon.user.core.UserStoreReader;

public class DelegatingUserStoreAdmin extends DelegatingUserStoreReader implements UserStoreAdmin {

    public DelegatingUserStoreAdmin(UserRealm defaultRealm) {
        super(defaultRealm);
    }

    public void addRole(String roleName) throws UserStoreException {

        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.addRole(roleName);
    }

    public void addUser(String userName, Object credential) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.addUser(userName, credential);
    }

    public void addUserToRole(String userName, String roleName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.addUserToRole(userName, roleName);

    }

    public void deleteRole(String roleName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.deleteRole(roleName);
    }

    public void deleteUser(String userName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.deleteUser(userName);
    }

    public void removeUserFromRole(String userName, String roleName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.removeUserFromRole(userName, roleName);
    }

    public void updateUser(String userName, Object newCredential, Object oldCredential)
            throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.updateUser(userName, newCredential, oldCredential);
    }

    public void updateUser(String userName, Object newCredential) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.updateUser(userName, newCredential);

    }

    public void updateRoleName(String roleName, String newRoleName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.updateRoleName(roleName, newRoleName);
    }

    public void updateUserName(String userName, String newUserName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        admin.updateUser(userName, newUserName);
    }

    // ******************************************************************************************

    public void setRoleProperties(String roleName, Map<String, String> properties)
            throws UserStoreException {
        throw new UserStoreException("NotImplemented");

    }

    public void deleteBinaryContent(String userName, String contentName) throws UserStoreException {

    }

    public void deleteUserProperties(String userName, String[] properties)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserProperty(String userName, String property) throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserBinaryContent(String userName, String contentName, byte[] data)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserProperties(String userName, Map<String, String> properties)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserProperty(String username, String attributeId, String attributeValue)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteBinaryContent(String userName, String contentName, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserClaimValue(String userName, String claimName, String claimValue,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserClaimValues(String userName, List<String> claims, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserClaimValues(String userName, String[] claims, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserProperties(String userName, String[] properties, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void deleteUserProperty(String userName, String property, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setProfilePicture(String userName, byte[] picture, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserBinaryContent(String userName, String contentName, byte[] data,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserClaimValue(String userName, String claimURI, String claimValue,
            String profileName) throws UserStoreException {
        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        if (profileName == null) {
            profileName = UserCoreConstants.DEFAULT_PROFILE;
        }
        admin.setUserClaimValue(userName, claimURI, claimValue, profileName);

    }

    public void setUserClaimValues(String userName, Map<String, String> claims, String profileName)
            throws UserStoreException {

        UserStoreAdmin admin = defaultRealm.getUserStoreAdmin();
        if (profileName == null) {
            profileName = UserCoreConstants.DEFAULT_PROFILE;
        }
        admin.setUserClaimValues(userName, claims, profileName);

    }

    public void setUserProperties(String userName, Map<String, String> properties,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public void setUserProperty(String username, String attributeId, String attributeValue,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub

    }

    public String[] getProfileNames() throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public byte[] getProfilePicture(String userName, String profileName) throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public byte[] getUserBinaryContent(String userName, String contentName, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public String getUserClaimValue(String userName, String claim, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public Map<String, String> getUserClaimValues(String userName, String[] claims,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public Map<String, String> getUserProperties(String userName, String[] propertyNames,
            String profileName) throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

    public String getUserPropertyValue(String userName, String propertyName, String profileName)
            throws UserStoreException {
        // TODO Auto-generated method stub
        return null;
    }

}
