package org.wso2.carbon.user.core.hybrid;

import java.sql.PreparedStatement;

import org.wso2.carbon.user.core.def.DefaultRealmConstants;
import org.wso2.carbon.user.core.def.SQLHelper;

public class HybridSQLHelper implements SQLHelper{

    public String getColumnName(int columnID) {
        String sqlString = null;
        switch (columnID) {
        case DefaultRealmConstants.COLUMN_ID_ATTR_NAME:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ATTR_NAME;
            break;
        case DefaultRealmConstants.COLUMN_ID_ATTR_VALUE:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ATTR_VALUE;
            break;
        case DefaultRealmConstants.COLUMN_ID_ID:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ID;
            break;
        case DefaultRealmConstants.COLUMN_ID_USER_NAME:
            sqlString = DefaultRealmConstants.COLUMN_NAME_USER_ID;
            break;
        case DefaultRealmConstants.COLUMN_ID_ROLE_NAME:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ROLE_ID;
            break;
        case DefaultRealmConstants.COLUMN_ID_ROLE_ID:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ROLE_ID;
            break;
        case DefaultRealmConstants.COLUMN_ID_USER_ID:
            sqlString = DefaultRealmConstants.COLUMN_NAME_USER_ID;
            break;
        case DefaultRealmConstants.COLUMN_ID_IS_ALLOWED:
            sqlString = DefaultRealmConstants.COLUMN_NAME_IS_ALLOWED;
            break;
        case DefaultRealmConstants.COLUMN_ID_CREDENTIAL:
            sqlString = DefaultRealmConstants.COLUMN_NAME_CREDENTIAL;
            break;
        case DefaultRealmConstants.COLUMN_ID_ACTION:
            sqlString = DefaultRealmConstants.COLUMN_NAME_ACTION;
            break;
        case DefaultRealmConstants.COLUMN_ID_RESOURCE_ID:
            sqlString = DefaultRealmConstants.COLUMN_NAME_RESOURCE_ID;
            break;
        default:
            System.out.println("Null");
            break;
        }
        return sqlString;
    }

    public String getSQL(int sqlID) {
        String sqlString = null;
        switch (sqlID) {
        case DefaultRealmConstants.ADD_ROLE:
            sqlString = HybridRealmConstants.ADD_ROLE_SQL;
            break;
        case DefaultRealmConstants.ADD_USER_ROLE:
            sqlString = HybridRealmConstants.ADD_USER_ROLE_SQL;
            break;
        case DefaultRealmConstants.GET_USER_ROLES:
            sqlString = HybridRealmConstants.GET_USER_ROLES_SQL;
            break;
        case DefaultRealmConstants.ADD_ROLE_ATTRIBUTE:
            sqlString = HybridRealmConstants.ADD_ROLE_ATTRIBUTE_SQL;
            break;
        case DefaultRealmConstants.DELETE_ROLE:
            sqlString = HybridRealmConstants.DELETE_ROLE_SQL;
            break;
        case DefaultRealmConstants.DELETE_USER_ROLE:
            sqlString = HybridRealmConstants.DELETE_USER_ROLE_SQL;
            break;
        case DefaultRealmConstants.DELETE_ROLE_ATTRIBUTE:
            sqlString = HybridRealmConstants.DELETE_ROLE_ATTRIBUTE_SQL;
            break;
        case DefaultRealmConstants.GET_ROLE:
            sqlString = HybridRealmConstants.GET_ROLE_SQL;
            break;
        case DefaultRealmConstants.ADD_PERMISSION:
            sqlString = HybridRealmConstants.ADD_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.ADD_ROLE_PERMISSION:
            sqlString = HybridRealmConstants.ADD_ROLE_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.ADD_USER_PERMISSION:
            sqlString = HybridRealmConstants.ADD_USER_PERMISSION_SQL;
            break;

        case DefaultRealmConstants.DELETE_PERMISSION_ON_RESOURCE:
            sqlString = HybridRealmConstants.DELETE_PERMISSION_ON_RESOURCE_SQL;
            break;
        case DefaultRealmConstants.DELETE_USER_PERMISSION:
            sqlString = HybridRealmConstants.DELETE_USER_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.DELETE_ROLE_PERMISSION:
            sqlString = HybridRealmConstants.DELETE_ROLE_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.GET_PERMISSION:
            sqlString = HybridRealmConstants.GET_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.GET_ROLE_AUTHORIZED:
            sqlString = HybridRealmConstants.GET_ROLE_AUTHORIZED_SQL;
            break;
        case DefaultRealmConstants.GET_USER_AUTHORIZED:
            sqlString = HybridRealmConstants.GET_USER_AUTHORIZED_SQL;
            break;
        case DefaultRealmConstants.GET_ROLES_FOR_RESOURCE:
            sqlString = HybridRealmConstants.GET_ROLES_FOR_RESOURCE_SQL;
            break;
        case DefaultRealmConstants.GET_USERS_ON_RESOURCE:
            sqlString = HybridRealmConstants.GET_USERS_ON_RESOURCE_SQL;
            break;
        case DefaultRealmConstants.GET_ROLE_PERMISSION:
            sqlString = HybridRealmConstants.GET_ROLE_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.GET_USER_PERMISSION:
            sqlString = HybridRealmConstants.GET_USER_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.GET_RESOURCE_PERMISSION:
            sqlString = HybridRealmConstants.GET_RESOURCE_PERMISSION_SQL;
            break;
        case DefaultRealmConstants.GET_RESOURCE_PERMISSION_COUNT:
            sqlString = HybridRealmConstants.GET_RESOURCE_PERMISSION_COUNT_SQL;
            break;   
        case DefaultRealmConstants.GET_ROLE_ATTRIBUTES:
            sqlString = HybridRealmConstants.GET_ROLE_ATTRIBUTES_SQL;
            break;
        case DefaultRealmConstants.GET_ATTRIBUTE_NAMES:
            sqlString = HybridRealmConstants.GET_ATTRIBUTE_NAMES_SQL;
            break;
        case DefaultRealmConstants.GET_USERS_IN_ROLE:
            sqlString = HybridRealmConstants.GET_USERS_IN_ROLE_SQL;
            break;
        case DefaultRealmConstants.GET_USERS_WITH_PROPERTY:
            sqlString = HybridRealmConstants.GET_USERS_WITH_PROPERTY_SQL;
            break;
        case DefaultRealmConstants.GET_USERS_WITH_PROPERTY_VALUE:
            sqlString = HybridRealmConstants.GET_USERS_WITH_PROPERTY_VALUE_SQL;
            break;
        case DefaultRealmConstants.GET_ROLES_ALL:
            sqlString = HybridRealmConstants.GET_ROLES_ALL_SQL;
            break;
        case DefaultRealmConstants.GET_ROLES_PERMISSION_FOR_RESOURCE:
            sqlString = HybridRealmConstants.GET_ROLES_PERMISSION_FOR_RESOURCE_SQL;
            break;
        case DefaultRealmConstants.GET_USER_PERMISSIONS:
            sqlString = HybridRealmConstants.GET_USER_PERMISSIONS_SQL;
            break;
        case DefaultRealmConstants.GET_ROLE_PERMISSIONS:
            sqlString = HybridRealmConstants.GET_ROLE_PERMISSIONS_SQL;
            break;
        case DefaultRealmConstants.GET_ID_FOR_ALL_ROLES:
            sqlString = HybridRealmConstants.GET_ID_FOR_ALL_ROLES_SQL;
            break;
        case DefaultRealmConstants.GET_EXISTING_ROLE_PERMISSIONS:
            sqlString = HybridRealmConstants.GET_EXISTING_ROLE_PERMISSIONS_SQL;
            break;
        case DefaultRealmConstants.GET_EXISTING_USER_PERMISSIONS:
            sqlString = HybridRealmConstants.GET_EXISTING_USER_PERMISSIONS_SQL;
            break;
        case DefaultRealmConstants.ON_DELETE_ROLE_UM_ROLE_PERMISSIONS:
            sqlString = HybridRealmConstants.ON_DELETE_ROLE_UM_ROLE_PERMISSIONS_SQL;
            break;            
        case DefaultRealmConstants.ON_DELETE_ROLE_UM_USER_ROLES:
            sqlString = HybridRealmConstants.ON_DELETE_ROLE_UM_USER_ROLES_SQL;
            break;            
        case DefaultRealmConstants.ON_DELETE_PERMISSION_UM_USER_PERMISSIONS:
            sqlString = HybridRealmConstants.ON_DELETE_PERMISSION_UM_USER_PERMISSIONS_SQL;
            break;
        case DefaultRealmConstants.ON_DELETE_PERMISSION_UM_ROLE_PERMISSIONS:
            sqlString = HybridRealmConstants.ON_DELETE_PERMISSION_UM_ROLE_PERMISSIONS_SQL;
            break;
        default:
            break;
        }
        return sqlString;
    }

    public String getUserProfileRelatedSQL(int sqlID) {
        // TODO Auto-generated method stub
        return null;
    }

    public void setUserIDInPrepStatement(String userName, int parameterIndex,
            PreparedStatement prepStmt) {
        // TODO Auto-generated method stub
        
    }
    
    

}
