package org.wso2.carbon.user.core.hybrid.actdir;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.ldap.InitialLdapContext;
import javax.naming.ldap.LdapContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.carbon.user.core.hybrid.ldap.LDAPRealmConfig;

public class ActDirRealmConfig {

    private String connectionURL = null;

    private String connectionName = null;

    private String connectionPassword = null;

    private String searchBase = null;

    private String driverName = "com.sun.jndi.ldap.LdapCtxFactory";
    
    private static Log log = LogFactory.getLog(ActDirRealmConfig.class);

    public ActDirRealmConfig() {

    }

    public String getDriverName() {
        return driverName;
    }

    public String getConnectionName() {
        return connectionName;
    }

    public String getSearchBase() {
        return searchBase;
    }

    public void setSearchBase(String searchBase) {
        this.searchBase = searchBase;
    }

    public String getConnectionURL() {
        return connectionURL;
    }

    public void setConnectionURL(String connectionURL) {
        this.connectionURL = connectionURL;
    }

    public void setConnectionName(String connectionName) {
        this.connectionName = connectionName.trim();
    }

    public String getConnectionPassword() {
        return connectionPassword;
    }

    public void setConnectionPassword(String connectionPassword) {
        this.connectionPassword = connectionPassword;
    }

    public LdapContext getContext() throws NamingException {

        LdapContext context = null;

        try {
            context = new InitialLdapContext(getDirectoryContextEnvironment(), null);
        } catch (NamingException e) {
            log.error(e.getMessage(), e);
            log.error("Creating ActDir connection for the second time");
            context = new InitialLdapContext(getDirectoryContextEnvironment(), null);
        } 
        return (context);

    }

    protected Hashtable getDirectoryContextEnvironment() {

        Hashtable env = new Hashtable();

        env.put(Context.INITIAL_CONTEXT_FACTORY, driverName);

        if (connectionName != null)
            env.put(Context.SECURITY_PRINCIPAL, connectionName);

        if (connectionPassword != null)
            env.put(Context.SECURITY_CREDENTIALS, connectionPassword);

        if (connectionURL != null)
            env.put(Context.PROVIDER_URL, connectionURL);

        env.put(Context.SECURITY_AUTHENTICATION, "simple");

        return env;

    }

}
