package org.wso2.carbon.user.core.internal;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.carbon.user.core.UserRealm;
import org.wso2.carbon.user.core.delegating.DelegatingRealm;

/**
 * @scr.component name="user.core.UserCoreServiceComponent" immediate="true"
 * @scr.reference name="user.realm.delegating" interface="org.wso2.carbon.user.core.UserRealm"
 *                cardinality="0..1" policy="dynamic" target="(RealmGenre=Hybrid)" bind="setUserRealmHybrid"
 *                unbind="unsetUserRealmHybrid"
 */
public class UserCoreServiceComponent {

    private static Log log = LogFactory.getLog(DelegatingRealm.class);
    
    private static UserRealm hybridRealm = null;
    
    protected void setUserRealmHybrid(UserRealm realm) {
        if (log.isDebugEnabled()) {
            log.info("Setting the Hybrid Realm");
        }
        hybridRealm = realm;
    }
    
    protected void unsetUserRealmHybrid(UserRealm realm) {
        if (log.isDebugEnabled()) {
            log.debug("Unsetting the Hybrid Realm");
        }
        hybridRealm = null;
    }

    public static UserRealm getHybridRealm() {
        return hybridRealm;
    }    
}
