package org.wso2.carbon.user.core.profile;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.sql.DataSource;

import org.wso2.carbon.user.core.ProfileConfiguration;
import org.wso2.carbon.user.core.UserProfileAdmin;
import org.wso2.carbon.user.core.UserStoreException;

public class BaseProfileAdmin implements UserProfileAdmin {

    //private Map<String, List<ProfileConfiguration>> profileConfigs = new ConcurrentHashMap<String, ProfileConfiguration>();
    private Map<String, ProfileConfiguration> profileConfigs = new ConcurrentHashMap<String, ProfileConfiguration>();
    private ProfileConfigDAO profileDAO = null;

    public BaseProfileAdmin(Map<String, ProfileConfiguration> profileConfigs, DataSource dataSource, String realmName) {
        this.profileConfigs = new ConcurrentHashMap<String, ProfileConfiguration>();
        this.profileConfigs.putAll(profileConfigs);
        profileDAO = new ProfileConfigDAO(dataSource, realmName);
    }

    public ProfileConfiguration getProfileConfig(String profileName) throws UserStoreException {
        return profileConfigs.get(profileName);
    }

    public void addProfileConfig(ProfileConfiguration profileConfig) throws UserStoreException {
        profileConfigs.put(profileConfig.getProfileName(), profileConfig);
        profileDAO.addProfileConfig(profileConfig);
    }

    public void updateProfileConfig(ProfileConfiguration profileConfig) throws UserStoreException {
        profileConfigs.put(profileConfig.getProfileName(), profileConfig);
        profileDAO.updateProfileConfig(profileConfig);
    }

    public void deleteProfileConfig(ProfileConfiguration profileConfig) throws UserStoreException {
        profileConfigs.remove(profileConfig.getProfileName());
        profileDAO.deleteProfileConfig(profileConfig);
    }

    public ProfileConfiguration[] getAllProfiles() throws UserStoreException {
        return profileConfigs.values().toArray(new ProfileConfiguration[profileConfigs.size()]);
    }

}
