package org.wso2.carbon.user.core.profile;

public class ProfileConstants {

    public static final String LOCAL_NAME_USER_PROFILES = "UserProfiles";

    public static final String ATTR_PROFILE_NAME = "profileName";
    public static final String ATTR_PROFILE_CONFIG_NAME = "configName";

    public static final String LOCAL_NAME_PROFILE_CONFIG = "ProfileConfiguration";
    public static final String LOCAL_NAME_CLAIM = "Claim";
    public static final String LOCAL_NAME_CLAIM_URI = "ClaimURI";
    public static final String LOCAL_NAME_ATTR_ID = "AttributeID";
    public static final String LOCAL_NAME_PROFILES = "Profiles";
    public static final String LOCAL_NAME_PROFILE = "Profile";
    public static final String LOCAL_NAME_CLAIM_BEHAVIOR = "ClaimBehavior";
    public static final String ATTR_DIALECT_URI = "dialectURI";

    public static final short BEHAVIOUR_INHERITED = 0;
    public static final short BEHAVIOUR_HIDDEN = 1;
    public static final short BEHAVIOUR_OVERRIDDEN = 2;

    //  "um_id integer generated by default as identity, " + "um_profile_name varchar(255), " +
    //"um_claim_id integer, " + "um_behaviour smallint, " +
    public static class Database {

        public static final String ADD_PROFILE_CONFIG = "INSERT INTO UM_PROFILE_CONFIG "
            + "(UM_PROFILE_NAME, UM_DIALECT_ID) VALUES(?,?)";

        public static final String ADD_CLAIM_BEHAVIOR = "INSERT INTO UM_CLAIM_BEHAVIOR "
            + "(UM_PROFILE_ID, UM_CLAIM_ID, UM_BEHAVIOUR) VALUES(?, ?,?)";

        public static final String GET_ALL_PROFILE_CONFIGS = "SELECT UM_CLAIM_URI, UM_PROFILE_NAME,"
            + "UM_BEHAVIOUR, UM_DIALECT_URI FROM UM_PROFILE_CONFIG, UM_CLAIM, UM_CLAIM_BEHAVIOR, UM_DIALECT "
            + "WHERE UM_CLAIM_BEHAVIOR.UM_CLAIM_ID=UM_CLAIM.UM_ID AND "
            + "UM_PROFILE_CONFIG.UM_ID=UM_CLAIM_BEHAVIOR.UM_PROFILE_ID AND "
            + "UM_PROFILE_CONFIG.UM_DIALECT_ID=UM_DIALECT.UM_ID";
        
        public static final String DELETE_PROFILE_CONFIG = "DELETE FROM UM_PROFILE_CONFIG "
            + "WHERE UM_PROFILE_NAME=? AND UM_DIALECT_ID=(SELECT UM_ID FROM UM_DIALECT WHERE UM_DIALECT_URI=? AND UM_REALM=?)";

        public static final String DELETE_CLAIM_BEHAVIOR = "DELETE FROM UM_CLAIM_BEHAVIOR "
            + "WHERE UM_PROFILE_ID=(SELECT UM_ID FROM UM_PROFILE_CONFIG WHERE UM_PROFILE_NAME=? AND UM_DIALECT_ID=(SELECT UM_ID FROM UM_DIALECT WHERE UM_DIALECT_URI=? AND UM_REALM=?))";

        public static final String GET_CLAIM_IDS = "SELECT UM_ID, UM_CLAIM_URI FROM UM_CLAIM";
    
        public static final String GET_DIALECT_ID = "SELECT UM_ID FROM UM_DIALECT WHERE UM_DIALECT_URI=?";
    
        public static final String GET_PROFILE_ID = "SELECT UM_ID FROM UM_PROFILE_CONFIG WHERE UM_PROFILE_NAME=?";
        
        public static final String ON_DIALECT_DELETE_REMOVE_PROFILE_CONFIGS = "DELETE FROM UM_PROFILE_CONFIG "
        + "WHERE UM_DIALECT_ID IN (SELECT UM_ID FROM UM_DIALECT WHERE UM_DIALECT_URI=? AND UM_REALM=?)";
            

    }

}
