package org.wso2.carbon.user.core.util;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.carbon.user.core.UserStoreException;

public class DatabaseUtil {

    private static Log log = LogFactory.getLog(DatabaseUtil.class);

    public static void closeConnection(Connection dbConnection) throws UserStoreException {
        try {
            if (dbConnection != null) {
                dbConnection.close();
            }
        } catch (SQLException e) {
            log.error("Database error. Could not close connections - " + e.getMessage(), e);
            throw new UserStoreException("Database error. Could not close connections.", e);
        }
    }

    public static void closeAllConnections(Connection dbConnection, PreparedStatement... prepStmts)
            throws UserStoreException {
        try {
            if (prepStmts != null && prepStmts.length > 0) {
                for (PreparedStatement stmt : prepStmts) {
                    if (stmt != null) {
                        stmt.close();
                    }
                }
            }
            if (dbConnection != null) {
                dbConnection.close();
            }
        } catch (SQLException e) {
            log.error("Database error. Could not close connections - " + e.getMessage(), e);
            throw new UserStoreException("Database error. Could not close connections.", e);
        }
    }

    public static void closeAllConnections(Connection dbConnection, ResultSet rs,
            PreparedStatement... prepStmts) throws UserStoreException {
        try {
            if (rs != null) {
                rs.close();
            }

            if (prepStmts != null && prepStmts.length > 0) {
                for (PreparedStatement stmt : prepStmts) {
                    if (stmt != null) {
                        stmt.close();
                    }
                }
            }

            if (dbConnection != null) {
                dbConnection.close();
            }
        } catch (SQLException e) {
            log.error("Database error. Could not close connections  - " + e.getMessage(), e);
            throw new UserStoreException("Database error. Could not close connections.", e);
        }
    }
    
    
    public static void closeAllConnections(Connection dbConnection, ResultSet rs1, ResultSet rs2,
            PreparedStatement... prepStmts) throws UserStoreException {
        try {
            if (rs1 != null) {
                rs1.close();
            }
            
            if (rs2 != null) {
                rs2.close();
            }

            if (prepStmts != null && prepStmts.length > 0) {
                for (PreparedStatement stmt : prepStmts) {
                    if (stmt != null) {
                        stmt.close();
                    }
                }
            }

            if (dbConnection != null) {
                dbConnection.close();
            }
        } catch (SQLException e) {
            log.error("Database error. Could not close connections  - " + e.getMessage(), e);
            throw new UserStoreException("Database error. Could not close connections.", e);
        }
    }

}
