<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError" %>
<%@page import="java.util.List"%>
<%@page import="java.util.Arrays"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<jsp:useBean id="roleBean" type="org.wso2.carbon.user.ui.client.RoleBean" scope="session"/>
<jsp:setProperty name="roleBean" property="*" />

<script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
    <carbon:breadcrumb label="add.system.permissions"
                       resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>

    <script type="text/javascript">
        function doValidation() {
            var reason = "";

        //    isChecked = isAtleastOneCheckedIfExisting("selectedPermissions");
        //    if (isChecked != true) {
        //        CARBON.showWarningDialog("<fmt:message key="please.select.at.least.one.permission"/>");
        //        return false;
        //    }
            return true;
        }

        function doCancel() {
            location.href = 'role-mgt.jsp?ordinal=1';
        }

        function doNext() {
            document.dataForm.action="add-step3.jsp";
            if(doValidation() == true){
                document.dataForm.submit();
            }
        }
        
        
        function goBack() {
        	location.href = 'add-step1.jsp?ordinal=2';
        }
    </script>

    <%
        String[] datas = null;
        String[] selected = null;
    
        try {
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);

            datas = client.getSystemPermissions();
            selected = roleBean.getSelectedPermissions();
        } catch (Exception e) {
            CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
            session.setAttribute(CarbonUIMessage.ID, uiMsg);
    %>
            <jsp:include page="../admin/error.jsp"/>
    <%
            return;
        }
    %>

    <div id="middle">
        <h2><fmt:message key="add.user.role"/></h2>

        <div id="workArea">
            <h3><fmt:message key="step.2.role"/></h3>
            <form method="get" action="add-finish.jsp" name="dataForm" onsubmit="return doValidation();" action="add-finish.jsp">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="add.system.permissions"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRaw">
                            <table class="normal">
                                <tr>
                                    <td>
                                      <a href="#" onclick="doSelectAll('selectedPermissions');"/><fmt:message key="select.all"/></a> | 
                                      <a href="#" onclick="doUnSelectAll('selectedPermissions');"/><fmt:message key="unselect.all"/></a>
                                    </td>
                                </tr>
                                <tr> 
                                    <td>       
                                        <table>
                                            <tbody>
                                            <%
                                                if (datas != null) {
                                                    List<String> list = Arrays.asList(selected); 
                                                    for (String data : datas) {
                                                        if (data != null) {
                                                            String docheck =  "";
                                                            if (list.contains(data)) {
                                                                docheck = "checked=\"checked\"";
                                                            }
                                                            
                                            %>
                                            <tr>
                                                <td><input type="checkbox"
                                                           name="selectedPermissions"
                                                           value="<%=data%>"  <%=docheck%>/><fmt:message key="<%=data%>"/>
                                                </td>
                                            </tr>
                                            <%
                                                        }
                                                    }
                                                }
                                            %>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                            <!-- normal table -->
                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input type="button" class="button" value="< <fmt:message key="back"/>" onclick="goBack();"/>
                            <input type="button" class="button" value="<fmt:message key="next"/> >" onclick="doNext();"/>
                            <input type="submit" class="button" value="<fmt:message key="finish"/>">
                            <input type="button" class="button" value="<fmt:message key="cancel"/>" onclick="doCancel();"/>
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>