<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page session="true" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="java.util.List" %>
<%@page import="java.util.Arrays" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="java.util.ArrayList" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>

<jsp:useBean id="roleBeanEditPermission" type="org.wso2.carbon.user.ui.client.RoleBean" class="org.wso2.carbon.user.ui.client.RoleBean" scope="session"/>
<jsp:setProperty name="roleBeanEditPermission" property="*"/>
    <%
        String[] permissions = null;
        String[] data = null;
        String roleName = request.getParameter("roleName");
        if(roleName == null || roleName.trim().length()==0){
            roleName = roleBeanEditPermission.getRoleName();
        }
        String userType = (String) request.getParameter("userType");
        session.setAttribute("org.wso2.carbon.user.userType", userType);
        try {

            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);

            if ("external".equals(userType)) {
                data = client.getSystemPermissionsOfExternalRole(roleName);
            }else if("special".equals(userType)){
                data = client.getSystemPermissionsOfSpecialInternalRole(roleName);
            } else {
                data = client.getSystemPermissionsOfRole(roleName);
            }

            permissions = client.getSystemPermissions();
        } catch (Exception e) {
            CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
            session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
            <jsp:include page="../admin/error.jsp"/>
<%
            return;
        }
%>

<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="add.remove.permissions"
		resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />

    <script type="text/javascript">
        function doValidation() {
            return true;
        }
    </script>
    
    <div id="middle">
        <h2><fmt:message key="edit.permissions.of.the.role"/></h2>

        <div id="workArea">
            <form method="get" action="edit-permissions-finish.jsp?"
                  onsubmit="return doValidation();">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th colspan="2"><fmt:message key="add.remove.permissions"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRow">
                            <table class="normal">
                   <tr>
                        <td><fmt:message key="name"/></td>
                        <td><%=roleName%><input type="hidden" name="roleName" value="<%=roleName%>"/></td>
                    </tr>
                    <tr>
                           <td><fmt:message key="permissions"/></td>
		                   <td>
		                       <a href="#" onclick="doSelectAll('selectedPermissions');"/><fmt:message key="select.all"/></a> | 
		                       <a href="#" onclick="doUnSelectAll('selectedPermissions');"/><fmt:message key="unselect.all"/></a>
		                   </td>
                    </tr>
                    <tr>
                        <td colspan="2">
                            <table>
                                <tbody>
                                <%
                                    List<String> list = new ArrayList<String>();
                                    if (data != null) {
                                        list = Arrays.asList(data);
                                    }
                                    if (permissions != null) {
                                        for (String value : permissions) {
                                            if (value != null) {
                                                String docheck = "";
                                                if (list.contains(value)) {
                                                    docheck = "checked=\"checked\"";
                                                }
                                %>
                                <tr>
                                    <td>
                                        <input type="checkbox" name="selectedPermissions"
                                               value="<%=value%>" <%=docheck%>/><fmt:message key="<%=value%>"/>
                                    </td>
                                </tr>
                                <%
                                            }
                                        }
                                    }

                                %>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                    </table>
                    </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input class="button" type="submit" value="<fmt:message key="update"/>"/>
                            <input class="button" type="button" value="<fmt:message key="cancel"/>" onclick="history.back()"/>
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>