<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError"%>

<%@page import="org.wso2.carbon.user.core.UserCoreConstants"%><script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>
<title>WSO2 Carbon - Security Configuration</title>

<%
    boolean showFilterMessage = false;
   
    session.removeAttribute("userBean");
    String[] datas = null;
    String filter = (String)request.getParameter("org.wso2.usermgt.internal.filter");
    if(filter == null){
	   filter = (String)session.getAttribute("org.wso2.usermgt.internal.filter");
    }
    
	if(filter == null){
	   filter = "*";
    }else{
	   filter = filter.trim();
	   session.setAttribute("org.wso2.usermgt.internal.filter", filter);
    }
		
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);

        if(filter.length() > 0){
            datas = client.listInternalUsers(filter);
            if(datas == null || datas.length == 0){
        	   showFilterMessage = true;
            }
        }

    } catch (Exception e) {
	   CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
       session.setAttribute(CarbonUIMessage.ID, uiMsg);
    %>
         <jsp:include page="../admin/error.jsp"/>
    <%
         return;
    }
        %>
        
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="users"
        resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
        topPage="false" request="<%=request%>" />

    <script type="text/javascript">

        function deleteUser(user) {
            function doDelete(){
                var userName = user;
                location.href = 'delete-finish.jsp?username=' + userName;
            }
            CARBON.showConfirmationDialog("<fmt:message key="confirm.delete.user"/> \'"+ user + "\'?", doDelete, null);
        }
        
       <% if(showFilterMessage == true){ %>
		jQuery(document).ready(function() {
            CARBON.showInfoDialog('<fmt:message key="no.users.filtered"/>', null, null);
   		});
       <% } %>
    </script>

    <div id="middle">
        <h2><fmt:message key="users"/></h2>
        <div id="workArea">
            <form name="filterForm" method="post" action="user-mgt.jsp">
		        <table class="normal">
		            <tr>
		                <td><fmt:message key="list.users"/></td>
		                <td>
		                   <input type="text" name="org.wso2.usermgt.internal.filter" value="<%=filter%>"/>
		                </td>
		                <td>
		                <input class="button" type="submit" value="<fmt:message key="user.search"/>" />
		                </td>
		            </tr>
		        </table>
	        </form>
	        <p>&nbsp;</p>
            <table class="styledLeft" id="userTable">
                <thead>
                <tr>
                    <th><fmt:message key="name"/></th>
                    <th><fmt:message key="actions"/></th>
                </tr>
                </thead>
                <tbody>
                <%
                    int count = 0;
                    String loggeduser = (String)request.getSession().getAttribute("logged-user");
                    if (datas != null) {
                        for (String data : datas) {
                            if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug Axis!!
                                
                        	    if(count == UserMgtClient.MAX_USER_COUNT){
                                    break;
                                }
                        	                             
                                if("anonymous".equals(data) || "guest".equals(data)){
                                    continue;
                                }                               
                                
                                count ++;
                %>
                <tr>
                    <td><%=data%>
                    </td>
                    <td>
                        <a href="change-passwd.jsp?username=<%=data%>" class="icon-link" style="background-image:url(../admin/images/edit.gif);"><fmt:message key="change.password"/></a>
                        <%
				        	if(CarbonUIUtil.isContextRegistered(config, "/userprofile/")){
				        %>
				        <a href="../userprofile/index.jsp?username=<%=data%>&userstore=<%=UserCoreConstants.INTERNAL_USERSTORE%>" class="icon-link" style="background-image:url(../userprofile/images/my-prof.gif);">User Profile</a>
				        <%
				            }
				        %>    
                        <%
                            if (!("admin".equals(data) || loggeduser.equals(data))) {
                        %>
<a href="#" onclick="deleteUser('<%=data%>')" class="icon-link" style="background-image:url(images/delete.gif);"><fmt:message key="delete"/></a>                       
                        <%
                            }
                        %>
        </td>
                </tr>
                <%
                            }
                        }
                    }
                %>
                </tbody>
            </table>
            <%
                if(datas != null){
                int length = datas.length; 
                    if(length > UserMgtClient.MAX_USER_COUNT){
                    %>
                    <strong><fmt:message key="more.users"/></strong>
                    <%
                    }
                }
            %>
             <%
              if(datas != null){
                  int length = datas.length; 
                  if(length > UserMgtClient.MAX_USER_COUNT){
                  %>
                  <strong><fmt:message key="more.users"/></strong>
                  <%
                  }
              }
             %>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" style="margin-top:2px;">
            <tr>
                <td class="addNewSecurity">
<a href="add-step1.jsp" class="icon-link" style="background-image:url(images/add.gif);"><fmt:message key="add.new.user"/></a>
</td>
            </tr>
        </table>
    </div>
    </div>
    <script language="text/JavaScript">
        alternateTableRows('userTable', 'tableEvenRow', 'tableOddRow');
    </script>
</fmt:bundle>