<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>

<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="add.external.user.store"
		resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />

<script type="text/javascript">

    function showHideStars(){
        var importRoles = document.getElementById("importRoles");
        var nostar1 = document.getElementById("nostar1");
        var nostar2 = document.getElementById("nostar2");
        var nostar3 = document.getElementById("nostar3");
        var star1 = document.getElementById("star1");
        var star2 = document.getElementById("star2");
        var star3 = document.getElementById("star3");
        if (importRoles.checked) {
            nostar1.style.display = "none";
            nostar2.style.display = "none";
            nostar3.style.display = "none";
            star1.style.display = "inline";
            star2.style.display = "inline";
            star3.style.display = "inline";
        }else{
            nostar1.style.display = "inline";
            nostar2.style.display = "inline";
            nostar3.style.display = "inline";
            star1.style.display = "none";
            star2.style.display = "none";
            star3.style.display = "none";
        }
    }
    
    function doValidationForJDBC() {
        var reason = "";
        reason = validateEmptyById("jconnectionURL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.url"/>");
            return false;
        }

        reason = validateEmptyById("jdriverName");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.driver.name"/>");
            return false;
        }
        
        reason = validateEmptyById("juserPasswordSQL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.valid.user.password.sql"/>");
            return false;
        }
        
        reason = validateEmptyById("juserFilterSQL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.valid.user.filter.sql"/>");
            return false;
        }
        
        reason = validateEmptyById("jisUserExistingSQL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.valid.single.user.select.sql"/>");
            return false;
        }
        
        reason = validateEmptyById("juserListSQL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.list.sql"/>");
            return false;
        }
        
        reason = validateStorePassword("jconnectionPassword");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.error"/>");
            return false;
        }
        
        reason = checkStorePasswordRetype("jconnectionPassword", "jconnectionPasswordRetype");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.retype.error"/>");
            return false;
        }
        
        var importRoles = document.getElementById("importRoles");
        if(importRoles.checked){
            
            reason = validateEmptyById("jroleListSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.role.list.sql"/>");
                return false;
            }
        
            reason = validateEmptyById("jusersInRoleSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.users.in.role.sql"/>");
                return false;
            }
        
            reason = validateEmptyById("juserRoleSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.user.role.sql"/>");
                return false;
            }
        
        }else{
            var elem1 = document.getElementById("jroleListSQL");
            elem1.value = null;
            var elem2 = document.getElementById("jusersInRoleSQL");
            elem2.value = null;
            var elem3 = document.getElementById("juserRoleSQL");
            elem3.value = null;
        }
        
        
        var importAttrs = document.getElementById("importAttrs");
        if(importAttrs.checked){
            reason = validateEmptyById("jattrsSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.attrs.sql"/>");
                return false;
            }
        }else{
            var elem2 = document.getElementById("jattrsSQL");
            elem2.value = null;
        }
        
        var importProfiles = document.getElementById("importMultipleProfiles");
        if(importProfiles.checked){
            reason = validateEmptyById("jprofileNamesSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.profiles.sql"/>");
                return false;
            }
            reason = validateEmptyById("jattrsForProfileSQL");
            if (reason != "") {
                CARBON.showWarningDialog("<fmt:message key="enter.valid.profiles.attrs.sql"/>");
                return false;
            }
        }else{
        	var elem1 = document.getElementById("jprofileNamesSQL");
            elem1.value = null;
            var elem2 = document.getElementById("jattrsForProfileSQL");
            elem2.value = null;
        }
        return true;
    }

    function doValidationForLDAP() {
        var reason = "";
        reason = validateEmptyById("lconnectionURL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.url"/>");
            return false;
        }
        reason = validateEmptyById("lconnectionName");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.name"/>");
            return false;
        }
        reason = validateEmptyById("lconnectionPassword");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.password"/>");
            return false;
        }
        reason = validateStorePassword("lconnectionPassword");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.error"/>");
            return false;
        }
        reason = checkStorePasswordRetype("lconnectionPassword", "lconnectionPasswordRetype");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.retype.error"/>");
            return false;
        }
        reason=validateEmpty("userContextName");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.valid.user.context"/>");
            return false;
        }
        reason=validateEmpty("uidSearchName");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.valid.uid.searchname"/>");
            return false;
        }
        return true;
    }

    function doValidationForAD() {
        var reason = "";
        reason = validateEmptyById("aconnectionURL");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.url"/>");
            return false;
        }
        reason = validateEmptyById("aconnectionName");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.name"/>");
            return false;
        }
        reason = validateEmptyById("aconnectionPassword");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.password"/>");
            return false;
        }
        reason = validateEmptyById("asearchBase");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="enter.a.valid.connection.password"/>");
            return false;
        }
        reason = validateStorePassword("aconnectionPassword");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.error"/>");
            return false;
        }
        reason = checkStorePasswordRetype("aconnectionPassword", "aconnectionPasswordRetype");
        if (reason != "") {
            CARBON.showWarningDialog("<fmt:message key="store.password.retype.error"/>");
            return false;
        }
        return true;
    }

    function showDivsOnTypeSelect() {
        var realmType = document.getElementById("realmType");
        var localjdbc = document.getElementById("jdbc-div");
        var localldap = document.getElementById("ldap-div");
        var localactivedir = document.getElementById("actdir-div");
        if (realmType.value == "JDBC") {
            localjdbc.style.display = "inline";
            localldap.style.display = "none";
            localactivedir.style.display = "none";
        }
        if (realmType.value == "LDAP") {
            localjdbc.style.display = "none";
            localldap.style.display = "inline";
            localactivedir.style.display = "none";
        }
        if (realmType.value == "AD") {
            localjdbc.style.display = "none";
            localldap.style.display = "none";
            localactivedir.style.display = "inline";
        }
    }

    function showAttrHideStars(){
        var importAttrs = document.getElementById("importAttrs");
        var nostar2 = document.getElementById("nostar5");
        var star2 = document.getElementById("star5");
        if (importAttrs.checked) {
            nostar2.style.display = "none";
            star2.style.display = "inline";
        }else{
            nostar2.style.display = "inline";
            star2.style.display = "none";
        }
    }

    function showHideMultipleProfilesStars(){
        var importProfiles = document.getElementById("importMultipleProfiles");
        var nostar1 = document.getElementById("nostar6");
        var star1 = document.getElementById("star6");
        var nostar2 = document.getElementById("nostar7");
        var star2 = document.getElementById("star7");
        if (importProfiles.checked) {
            star1.style.display = "inline";
            star2.style.display = "inline";
            nostar1.style.display = "none";
            nostar2.style.display = "none";
        }else{
        	star1.style.display = "none";
            star2.style.display = "none";
            nostar1.style.display = "inline";
            nostar2.style.display = "inline";
        }
    }
    
    function doCancel() {
        location.href = 'index.jsp';
    }
</script>
<div id="middle">
    <h2><fmt:message key="add.external.user.store"/></h2>

    <div id="workArea">
        <table class="normal">
            <tr>
                <td><fmt:message key="external.store.type"/></td>
                <td>
                    <select onchange="showDivsOnTypeSelect();" id="realmType" name="realmType">
                        <option value="JDBC">JDBC</option>
                        <option value="LDAP">LDAP</option>
                        <option value="AD">Active Directory</option>
                    </select>
                </td>
            </tr>
        </table><br/>
        <!-- Divs of user stores are beginning -->

        <!-- jdbc -->

        <div id="jdbc-div" style="display:inline;">
            <form id="jdbc-form" name="jdbc-form" action="add-finish.jsp"
                  onsubmit="return doValidationForJDBC();">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="jdbc.store.properties"/></th>
                    </tr>
                    </thead>
<tr>
<td class="nopadding">
<table class="normal-nopadding" cellspacing="0">
                    <tr>
                        <td width="15%"><nobr><fmt:message key="connection.url"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="connectionURL" id="jconnectionURL"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="connection.user.name"/></nobr></td>
                        <td><input type="text" name="connectionName" id="jconnectionName"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="connection.password"/></nobr></td>
                        <td><input type="password" name="connectionPassword" id="jconnectionPassword" style="width: 142px !important;"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="connection.password.retype"/></nobr></td>
                        <td><input type="password" name="connectionPasswordRetype" id="jconnectionPasswordRetype" style="width: 142px !important;"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="driver.name"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="driverName" id="jdriverName"/></td>
                    </tr>
                 
                    <tr>
                        <td class="middle-header" colspan="2"><fmt:message key="user.information"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="sql.for.retriving.a.given.user.s.password"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="userPasswordSQL" id="juserPasswordSQL"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="sql.for.listing.users"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="userFilterSQL" id="juserFilterSQL"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="sql.for.selecting.single.user"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="isUserExistingSQL" id="jisUserExistingSQL"/></td>
                    </tr>
                    <tr>
                        <td><nobr><fmt:message key="sql.for.retriving.a.user.list"/><font color="red">*</font></nobr></td>
                        <td><input type="text" name="userListSQL" id="juserListSQL"/></td>
                    </tr>
                    <tr>
                        <td class="middle-header" colspan="3"><fmt:message key="role.information"/></td>
                    </tr>
                    <tr>
                        <td colspane="2">
                        <input type="checkbox" id="importRoles" name="importRoles" onclick="showHideStars();"/>
                        <fmt:message key="import.roles.from.the.database"/>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        <div id="nostar1"><nobr><fmt:message key="sql.for.retrieving.a.given.user.s.role.list"/></nobr></div>
                        <div id="star1"  style="display:none;"><fmt:message key="sql.for.retrieving.a.given.user.s.role.list"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="userRoleSQL" id="juserRoleSQL"/></td>
                    </tr>
                    <tr>
                        <td>
                        <div id="nostar2"><nobr><fmt:message key="sql.for.retrieving.users.in.a.role"/></nobr></div>
                        <div id="star2"  style="display:none;"><fmt:message key="sql.for.retrieving.users.in.a.role"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="usersInRoleSQL" id="jusersInRoleSQL"/></td>
                    </tr>
                    <tr>
                        <td>
                        <div id="nostar3"><nobr><fmt:message key="sql.for.listing.the.role.list"/></nobr></div>
                        <div id="star3" style="display:none;"><fmt:message key="sql.for.listing.the.role.list"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="roleListSQL" id="jroleListSQL"/></td>
                    </tr>
                    <tr>
                        <td class="middle-header" colspan="3"><fmt:message key="user.attrs.information"/></td>
                    </tr>
                    <tr>
                        <td colspane="2">
                        <input type="checkbox" id="importAttrs" name="importAttrs" onclick="showAttrHideStars();"/>
                        <fmt:message key="import.attrs.from.the.database"/>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        <div id="nostar5"><nobr><fmt:message key="sql.for.retrieving.an.attribute.values"/></nobr></div>
                        <div id="star5"  style="display:none;"><fmt:message key="sql.for.retrieving.an.attribute.values"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="attrsSQL" id="jattrsSQL"/></td>
                    </tr>
                    <tr>
                        <td colspane="2">
                        <input type="checkbox" id="importMultipleProfiles" name="importMultipleProfiles" onclick="showHideMultipleProfilesStars();"/>
                        <fmt:message key="import.multiple.profiles"/>
                        </td>
                    </tr>
                   <tr>
                        <td>
                        <div id="nostar6"><nobr><fmt:message key="sql.for.retrieving.profile.names"/></nobr></div>
                        <div id="star6"  style="display:none;"><fmt:message key="sql.for.retrieving.profile.names"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="profileNamesSQL" id="jprofileNamesSQL"/></td>
                    </tr>
                    <tr>
                        <td>
                        <div id="nostar7"><nobr><fmt:message key="sql.for.retrieving.attr.values.for.profile"/></nobr></div>
                        <div id="star7"  style="display:none;"><fmt:message key="sql.for.retrieving.attr.values.for.profile"/><font color="red">*</font></div>
                        </td>
                        <td><input type="text" name="attrsForProfileSQL" id="jattrsForProfileSQL"/></td>
                    </tr>
                   
</table>
</td>
</tr>
 
                    <tr>

                        <td class="buttonRow">
                            <input value="<fmt:message key="finish"/>" type="submit" class="button"/>
                            <input value="<fmt:message key="cancel"/>" type="button" onclick="doCancel();" class="button"/>
                        </td>
                    </tr>
                </table>
                <input type="hidden" name="realmType" value="jdbc"/>
            </form>
        </div>

        <!-- ldap -->

        <div id="ldap-div" style="display:none;">
            <form id="ldap-form" name="ldap-form" action="add-finish.jsp"
                  onsubmit="return doValidationForLDAP();">
                    <table class="styledLeft">
                        <thead>
                        <tr>
                            <th><fmt:message key="ldap.store.properties"/></th>
                        </tr>
                        </thead>
<tr>
<td class="formRaw">
<table class="normal">
                        <tr>
                            <td><fmt:message key="connection.url"/><font color="red">*</font></td>
                            <td><input type="text" name="connectionURL" id="lconnectionURL"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="connection.user.name"/><font color="red">*</font></td>
                            <td><input type="text" name="connectionName" id="lconnectionName"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="connection.password"/><font color="red">*</font></td>
                            <td><input type="password" name="connectionPassword" id="lconnectionPassword"/></td>
                        </tr>
                         <tr>
                            <td><fmt:message key="connection.password.retype"/><font color="red">*</font></td>
                            <td><input type="password" name="connectionPasswordRetype" id="lconnectionPasswordRetype"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="user.context.name"/><font color="red">*</font></td>
                            <td><input type="text" name="userContextName" id="luserContextName"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="user.searchname"/><font color="red">*</font></td>
                            <td><input type="text" name="UIDSearchName" id="luserPattern"/></td>
                        </tr>
</table>
</td>
</tr>
<tr>
                            <td class="buttonRow">
                                <input value="<fmt:message key="finish"/>" type="submit" class="button"/>
                                <input value=" <fmt:message key="cancel"/> " type="button" onclick="doCancel();" class="button"/>
                            </td>
                        </tr>

                    </table>
                <input type="hidden" name="realmType" value="ldap"/>
            </form>
        </div>

        <!-- actdir -->

        <div id="actdir-div" style="display:none;">
            <form id="actdir-form" name="actdir-form" action="add-finish.jsp"
                  onsubmit="return doValidationForAD();">
                    <table class="styledLeft">
                        <thead>
                        <tr>
                            <th><fmt:message key="active.directory.store.properties"/></th>
                        </tr>
                        </thead>
<tr>
<td class="formRaw">
<table class="normal">
                        <tr>
                            <td><fmt:message key="connection.url"/><font color="red">*</font></td>
                            <td><input type="text" name="connectionURL" id="aconnectionURL"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="user.dn"/><font color="red">*</font></td>
                            <td><input type="text" name="connectionName" id="aconnectionName"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="connection.password"/><font color="red">*</font></td>
                            <td><input type="password" name="connectionPassword" id="aconnectionPassword"/></td>
                        </tr>
                         <tr>
                            <td><fmt:message key="connection.password.retype"/><font color="red">*</font></td>
                            <td><input type="password" name="connectionPasswordRetype" id="aconnectionPasswordRetype"/></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="search.dn"/><font color="red">*</font></td>
                            <td><input type="text" name="searchBase" id="asearchBase"/></td>
                        </tr>
</table>
</td>
</tr>
                        <tr>
                            <td class="buttonRow">
                                <input value="<fmt:message key="finish"/>" type="submit" class="button"/>
                                <input value=" <fmt:message key="cancel"/> " type="button" onclick="doCancel();" class="button"/>
                            </td>
                        </tr>
                        <input type="hidden" name="realmType" value="act-dir"/>
                    </table>
            </form>
        </div>

    </div>
    <!-- formset -->
</div>
<!-- middle -->
</fmt:bundle>