<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<script type="text/javascript" src="extensions/core/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>

<%
    boolean hasExternal = false;
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(),
                session);
        ConfigurationContext configContext = (ConfigurationContext) config
                .getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);

        hasExternal = client.hasExternalUserStore();

    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="system.user.store"
		resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
		topPage="true" request="<%=request%>" />


    <script type="text/javascript">
        function deleteUserStore() {
            CARBON.showConfirmationDialog('<fmt:message key="confirm.delete.userstore"/> ' + '?', doDelete, null);
        }
        
        function doDelete(){
            location.href = 'delete-finish.jsp';
        }

    </script>


    <div id="middle">
        <h2><fmt:message key="user.management"/></h2>

        <div id="workArea">
            <table width="100%">
                <tr>
                    <td>
                        <table class="styledLeft" id="internal" width="100%">

			                <thead>
                                <tr>
                                    <th><fmt:message key="system.user.store"/></th>
                                </tr>
                            </thead>
                            <tr>
                                <td>
                                <a class="icon-link" style="background-image:url(images/users.gif);" href="../user/user-mgt.jsp"><fmt:message key="users"/></a>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                <a class="icon-link" style="background-image:url(images/user-roles.gif);" href="../role/role-mgt.jsp"><fmt:message key="roles"/></a>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                </tr>
                <tr>
                    <td>
                        <table class="styledLeft" id="external" width="100%">
			<thead>
                            <tr>
                                <th><fmt:message key="external.user.store"/></th>
                            </tr>
			</thead>
                            <%
                                if (hasExternal) {
                            %>
                            <tr>
                                <td><a href="ex-user-mgt.jsp" class="icon-link" style="background-image:url(images/external-users.gif);"><fmt:message key="external.users"/></a></td>
                            </tr>
                            <tr>
                                <td><a href="ex-role-mgt.jsp" class="icon-link" style="background-image:url(images/external-roles.gif);"><fmt:message key="external.roles"/></a></td>
                            </tr>
                            <tr>
                                <td><a href="config-mgt.jsp" class="icon-link" style="background-image:url(images/view.gif);"><fmt:message key="view.external.store.configuration"/></a></td>
                            </tr>
                            <tr>
                                <td><a href="config-edit.jsp" class="icon-link" style="background-image:url(images/edit.gif);"><fmt:message key="edit.external.store.configuration"/></a></td>
                            </tr>
                            <tr>
                                <td><a href="#" class="icon-link" style="background-image:url(images/delete.gif);" onclick="deleteUserStore()"><fmt:message key="delete.external.user.store"/></a></td>
                            </tr>
                            <tr>
                                <td><a href="test-connection.jsp" class="icon-link" style="background-image:url(images/test.gif);"><fmt:message key="test.connection"/></a></td>
                            </tr>
                            <%
                            } else {
                            %>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/external-users.gif);"><fmt:message key="external.users"/></span></td>
                            </tr>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/external-roles.gif);"><fmt:message key="external.roles"/></span></td>
                            </tr>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/view.gif);"><fmt:message key="view.external.store.configuration"/></span></td>
                            </tr>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/edit.gif);"><fmt:message key="edit.external.store.configuration"/></span></td>
                            </tr>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/delete.gif);"><fmt:message key="delete.external.user.store"/></span></td>
                            </tr>
                            <tr>
                                <td><span class="icon-text-disabled" style="background-image:url(images/test.gif);"><fmt:message key="test.connection"/></span></td>
                            </tr>
                            <%

                                }
                            %>

                        </table>
                    </td>
                </tr>
            </table>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td>
    <%
        if (hasExternal) {
    %>
<span class="icon-text-disabled" style="background-image:url(images/add.gif);"><fmt:message key="add.external.user.store"/></span>
    <%
        }else{
    %>     
<a href="add-step1.jsp" class="icon-link" style="background-image:url(images/add.gif);"><fmt:message key="add.external.user.store"/></a>
    <%
        }
    %>

</td>
            </tr>
        </table>
	
        </div>
    </div>
    <script type="text/javascript">
        alternateTableRows('internal', 'tableEvenRow', 'tableOddRow');
        alternateTableRows('external', 'tableEvenRow', 'tableOddRow');
    </script>
</fmt:bundle>