/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.carbon.utils;
/*
 * 
 */

public final class WSO2Constants {

    public static final String FILE_RESOURCE_MAP = "file.resource.map";
    public static final String WORK_DIR = "WORK_DIR";
    public static final String WSO2WSAS_INSTANCE = "WSO2 WSAS";
    public static final String WEB_RESOURCE_LOCATION = "web.location";
    public static final String GENERATED_PAGES = "wso2wsas.generated.pages";
    public static final String CONFIGURATION_CONTEXT = "CONFIGURATION_CONTEXT";

	public static final String HTTP_PORT = "wso2utils.http.port";
	public static final String HTTPS_PORT = "wso2utils.https.port";
    public static final String PROXY_PORT = "proxyPort";

    public static class ContextPaths {
        public static final String UPLOAD_PATH = "/fileupload";
        public static final String DOWNLOAD_PATH = "/filedownload";
        public static final String SERVER_PATH = "/server";
    }

    public final static String REGISTRY_INSTANCE = "WSO2Registry";

    public final static String BUNDLE_ID = "bundleId";

    public final static String PRIMARY_BUNDLE_CONTEXT = "primaryBundleContext";

	public final static String PROTECTED_TOKENS = "ProtectedTokens";
	public static final String PASSWORD_PROVIDER = "PasswordProvider";
	public static final String IS_PASSWROD_ENCRYPTED = "isPasswordEncrypted";
}
