package org.wso2.carbon.utils.security;

import java.util.Properties;

/**
 * This provide abstraction to get resolve actual password
 * By implementing this, it is possible to securely provide passwords.
 * This is not a solution but just API, implementer has to be cared about how to keep password securely.
 */
public interface PasswordProvider {
    /**
     * Initialization of the password provider with configuration properties.
     *
     * @param properties Properties to be used for initialization
     */
    void init(Properties properties);

    /**
     * Getting resolved alias password
     *
     * @param encryptedPassword Alias password - this can be encrypted value or not
     * @return Resolved password
     */
    String resolve(String encryptedPassword);
}
